<?php

namespace Drupal\webform_gpn\Plugin\WebformElement;

use Drupal\Core\Form\FormStateInterface;
use Drupal\webform\Plugin\WebformElementBase;

/**
 * Provides a 'webform_georgian_personal_number'.
 *
 * @WebformElement(
 *   id = "webform_georgian_personal_number",
 *   label = @Translation("Georgian Personal Number"),
 *   description = @Translation("Provides a field for a Georgian Personal Number"),
 *   category = @Translation("Custom"),
 *   states_wrapper = TRUE,
 * )
 */
class WebformGeorgianPersonalNumber extends WebformElementBase {

  /**
   * {@inheritdoc}
   */
  public function getDefaultProperties(): array {
    return parent::getDefaultProperties() + [
      'multiple' => '',
      'size' => '',
      'minlength' => '',
      'maxlength' => '',
      'placeholder' => '',
      'error_message' => '',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function form(array $form, FormStateInterface $form_state): array {
    $form = parent::form($form, $form_state);

    $form['gpn'] = [
      '#type' => 'details',
      '#title' => $this->t('Georgian Personal Number'),
    ];

    $form['gpn']['error_message'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Error message'),
      '#description' => $this->t('This message will be shown when the user fills in an invalid Georgian Personal Number.'),
    ];
    return $form;
  }

}
